;*********************************************************
; Lines f. Hbler-Grafik-PC ala MS Screensaver
; Quelle: FADEN.MAC Mario Leubner (KV 85/4)
; Anpassung an Hbler-Grafik-PC V. Pohlers 07.05.2012
;*********************************************************
; es werden die Monitorfunktionen fr Grafik genutzt
;
; Start: GO 100
; Tasten: 
;	+ -> mehr Linien
;	- -> weniger Linien
;	H -> hor. Spiegelung ein/aus
;	V -> vert. Spiegelung ein/aus
;	sonst:	Ende
;*********************************************************

	cpu	z80

CI	equ	0F003h
CSTS	equ	0F012h
CO	equ	0F009h

ESC	equ	1Bh
	
	org	100h

TOP:	CALL	FADEN1		; Programm ausfuehren
	RET
	
;
; Erzeugung einer Zufallszahl
; (im Bereich von 3 bis 15)
;
RND:	EXX
	LD	A,0	; Zwischenablage
ZAHL	EQU	$-1
	INC	A
	LD	D,A
	;
	ADD	A,A
	ADD	A,A
	ADD	A,A
	ADD	A,A
	SUB	D	; Zahl*15
	;
	ADD	A,A
	LD	L,A
	LD	A,R
	ADD	A,L
	LD	(ZAHL),A
	LD	B,13
RND1:	SUB	B
	CP	B
	JR	NC,RND1
	ADD	A,3
	EXX
	RET
;
; FADEN-Hauptschleife:
;
FADEN:	LD	HL,(ZYKLUS)
	INC	HL		; Zykluszaehler
	BIT	1,H
	RES	1,H
	LD	(ZYKLUS),HL
	JR	Z,FADEN2

FADEN1:	LD	C,0Ch		; CLS, Bild loeschen
	CALL	CO
	LD	HL,MEM		; Variablenspeicher
	LD	(ZEIGER),HL
	LD	DE,MEM+1
	LD	BC,127
	LD	(HL),0		; Variablen loeschen
	LDIR
FADEN2:	LD	HL,X1		; Koordinaten und
	LD	DE,ZUF1		; dazugehoerige Zufallszahlen
	LD	B,4		; fuer 4 Werte
NEU:	LD	A,(HL)
	AND	A
	JR	NZ,NEU1
	CALL	RND		; Koordinate=0
	LD	(DE),A		; positive Zufallszahl
NEU1:	LD	A,(HL)
	INC	A
	JR	NZ,NEU2
	CALL	RND		; Koordinate=ffh
	NEG
	LD	(DE),A		; negative Zufallszahl
NEU2:	INC	HL
	INC	DE
	DJNZ	NEU
;
; Linie(n) zeichnen
;
	LD	HL,(X1)
	LD	D,L
	LD	B,H
	LD	HL,(Y1)
	LD	E,L
	LD	C,H
	CALL	LINES		; 1. Linie
	LD	A,(MIRR)
	RRA			; H-Spiegel?
	JR	NC,NOSP1
	LD	A,(Y1)
	CPL
	LD	(Y3),A
	LD	A,(Y2)
	CPL
	LD	(Y4),A
	LD	HL,(X1)
	LD	D,L
	LD	B,H
	LD	HL,(Y3)
	LD	E,L
	LD	C,H
	CALL	LINE		; 2. Linie
NOSP1:	LD	A,(MIRR)
	RLA			; V-Spiegel?
	JR	NC,NOSP2
	LD	A,(X1)
	CPL
	LD	(X3),A
	LD	A,(X2)
	CPL
	LD	(X4),A
	LD	HL,(X3)
	LD	D,L
	LD	B,H
	LD	HL,(Y1)
	LD	E,L
	LD	C,H
	CALL	LINE		; 3. Linie
	LD	A,(MIRR)
	RRA			; H-Spiegel?
	JR	NC,NOSP2
	LD	HL,(X3)
	LD	D,L
	LD	B,H
	LD	HL,(Y3)
	LD	E,L
	LD	C,H
	CALL	LINE		; 4. Linie
NOSP2:
;
; Retten der aktuellen Koordinaten
;
	LD	DE,(ZEIGER)
	LD	HL,X1
	LD	BC,4
	LDIR
	LD	HL,(GRENZE)
	AND	A
	SBC	HL,DE
	JR	NZ,NEWZG
	LD	DE,MEM		; Zeiger wieder von vorn
NEWZG:	LD	(ZEIGER),DE
;
; alte Linie(n) loeschen
;
	LD	HL,(ZEIGER)
	LD	D,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	E,(HL)
	INC	HL
	LD	C,(HL)
	CALL	LINER		; 1. Linie
	LD	A,(MIRR)
	RRA			; H-Spiegel?
	JR	NC,NOSP3
	LD	HL,(ZEIGER)
	LD	D,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	A,(HL)
	CPL
	LD	E,A
	INC	HL
	LD	A,(HL)
	CPL
	LD	C,A
	CALL	LINE		; 2. Linie
NOSP3:	LD	A,(MIRR)
	RLA			; V-Spiegel?
	JR	NC,NOSP4
	LD	HL,(ZEIGER)
	LD	A,(HL)
	CPL
	LD	D,A
	INC	HL
	LD	A,(HL)
	CPL
	LD	B,A
	INC	HL
	LD	E,(HL)
	INC	HL
	LD	C,(HL)
	CALL	LINE		; 3. Linie
	LD	A,(MIRR)
	RRA			; H-Spiegel
	JR	NC,NOSP4
	LD	HL,(ZEIGER)
	LD	A,(HL)
	CPL
	LD	D,A
	INC	HL
	LD	A,(HL)
	CPL
	LD	B,A
	INC	HL
	LD	A,(HL)
	CPL
	LD	E,A
	INC	HL
	LD	A,(HL)
	CPL
	LD	C,A
	CALL	LINE		; 4. Linie
NOSP4:
;
; Koordinaten fuer naechste Linie
; aus den Zufallszahlen berechnen
;
	LD	HL,ZUF1		; Richtung
	LD	DE,X1		; Koordinaten
	LD	B,4		; fuer 4 Werte
CALC:	LD	A,(DE)
	ADD	A,(HL)		; neuer Wert
	BIT	7,(HL)
	JR	NZ,CALC2
	JR	NC,CALC3
	LD	A,-1		; max. Wert (Umlenkpunkt)
	JR	CALC3
	;
CALC2:	JR	C,CALC3
	XOR	A		; min. Wert (Umlenkpunkt)
CALC3:	LD	(DE),A
	INC	HL
	INC	DE
	DJNZ	CALC

;
; Tastaturabfrage/Auswertung
;
	CALL 	CSTS 		;Taste gedrckt?
	AND	A
	JP	Z,FADEN		; keine Taste
	CALL	CI		;welche Taste?
	CP	'+'
	JR	Z,PLUS		; (+) -> mehr Linien
	CP	'-'
	JR	Z,MINUS		; (-) -> weniger Linien
	AND	5FH		; upcase
	CP	'H'
	JR	Z,HSWI		; (H) -> hor. Spiegelung ein/aus
	CP	'V'
	JR	Z,VSWI		; (V) -> vert. Spiegelung ein/aus
	RET			; jede andere Taste bricht ab!
;
; zwei Linien mehr
;
PLUS:	LD	HL,MEM+128
	LD	DE,(GRENZE)
	AND	A
	SBC	HL,DE
	JP	Z,FADEN
	LD	HL,8
SET1:	ADD	HL,DE
	LD	(GRENZE),HL
	JP	FADEN1
;
; zwei Linien weniger
;
MINUS:	LD	HL,MEM+8
	LD	DE,(GRENZE)
	AND	A
	SBC	HL,DE
	JP	Z,FADEN
	LD	HL,-8
	JR	SET1
;
; hor. Spiegelung ein/aus
;
HSWI:	LD	A,(MIRR)
	XOR	1
	JR	SET2
;
; vert. Spiegelung ein/aus
;
VSWI:	LD	A,(MIRR)
	XOR	80H
SET2:	LD	(MIRR),A
	JP	FADEN1
;
; Schnelle LINE-Routine (im Feld 256*256 Punkte) - nur Pixel
;
; Prinzip: Alle Linien sind aus Teilstuecken gerader Linienelemente,
;	   der 8 Grundrichtungen zusammengesetzt werden. Eine einzelne
;	   Linie besteht dabei aus max. zwei verschiedenen Richtungen
;	   (gerade oder 45grad schraeg).
;
; von:	D=X1	E=Y1
; nach:	B=X2	C=Y2
;

LINES:	push	bc
	ld	c, ESC
	call	CO
	ld	c, 08h		; PEN
	call	CO
	pop	bc
	jr	LINE
;
LINER:	push	bc
	ld	c, ESC
	call	CO
	ld	c, 07h		; ERASER
	call	CO
	pop	bc
;	

LINE:	LD	H,B		;2. Koordinate nach HL
	LD	L,C
	
	ld	c, ESC
	call	CO
	ld	c, 03h		; DRAW
	call	CO
		
	RET

; --- initialisierte Daten ---

ZYKLUS:	DW	0		; Zykluszaehler (Farbwechsel)
ZEIGER:	DW	MEM		; Zeiger
GRENZE:	DW	MEM+50H		; Grenze

X1:	DB	10		; Koordinaten
X2:	DB	100
Y1:	DB	20
Y2:	DB	200
X3:	DB	256-10		; Koordinaten negiert
X4:	DB	256-100
Y3:	DB	256-20
Y4:	DB	256-200

ZUF1:	DB	4		; 4 Zufallszahlen
ZUF2:	DB	13
ZUF3:	DB	10
ZUF4:	DB	7

MIRR:	DB	0		; hor./vert. Spiegel ein/aus

SIZE1	EQU	$-TOP		; Groesse Programmsegment

; --- nicht zu initialisierende Daten ---

PTRX:	DS	12	; Vergleichswerte Ringpufferzeiger

MEM:	DS	32*4	; Koordinatenspeicher (32 Linien)

SIZE2	EQU	$-PTRX	; Groesse Datensegment

	END
